<?xml version="1.0" encoding="euc-jp"?>
<!-- $Id: amanuensis-html.xsl 131 2006-03-21 02:44:28Z syl $ -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:output method="html" encoding="euc-jp"/>

  <xsl:template match="/dtd">
    <html>
      <head>
        <meta HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP"/>
        <link rel="stylesheet" type="text/css" href="amanuensis.css"/>
      </head>
      <body>
        <p class="elementTitle">Reference</p>

        <xsl:for-each select="element|entity">
          <!-- <xsl:sort select="name()"/> -->
          <xsl:sort select="@name"/>

          <xsl:element name="a">
            <xsl:attribute name="href">
              <xsl:text>#</xsl:text>
              <xsl:value-of select="@name"/>
            </xsl:attribute>

            <xsl:choose>
              <xsl:when test="name() = 'element'">
                <xsl:text>&lt;</xsl:text>
                <xsl:value-of select="@name"/>
                <xsl:text>&gt;</xsl:text>
              </xsl:when>
              <xsl:when test="name() = 'entity'">
                <xsl:value-of select="@name"/>
                <xsl:text>ѥ᡼</xsl:text>
              </xsl:when>
            </xsl:choose>
          </xsl:element>

          <xsl:text> </xsl:text>
        </xsl:for-each>

        <xsl:apply-templates>
          <!-- <xsl:sort select="name()"/> -->
          <xsl:sort select="@name"/>
        </xsl:apply-templates>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="/dtd/element">
    <hr/>
    <xsl:element name="a">
      <xsl:attribute name="name">
        <xsl:value-of select="@name"/>
      </xsl:attribute>
    </xsl:element>
    <p class="element"><xsl:value-of select="@name"/></p>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/dtd/element/include">
    <p class="elementSection">礹</p>
    <p class="elementInclude"><xsl:apply-templates/></p>
  </xsl:template>

  <xsl:template name="attribute">
    <dt>
      <i><xsl:value-of select="@name"/></i>
      <xsl:text></xsl:text>
      <xsl:value-of select="@type"/>
      <xsl:text></xsl:text>
      <xsl:choose>
        <xsl:when test="@optional = 'IMPLIED'">
          <xsl:text>άǽ</xsl:text>
        </xsl:when>
        <xsl:when test="@optional = 'REQUIRED'">
          <xsl:text>ɬ</xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="@optional"/> 
        </xsl:otherwise>
      </xsl:choose>
    </dt>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/dtd/element/attr">
    <xsl:call-template name="attribute"/>
  </xsl:template>

  <xsl:template match="/dtd/element/attr[1]">
    <p class="elementSection">°</p>
    <xsl:call-template name="attribute"/>
  </xsl:template>

  <xsl:template match="/dtd/element/attr/desc">
    <dd><xsl:apply-templates/></dd>
  </xsl:template>

  <xsl:template match="/dtd/element/desc">
    <p class="elementSection"></p>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/dtd/entity">
    <hr/>
    <xsl:element name="a">
      <xsl:attribute name="name">
        <xsl:value-of select="@name"/>
      </xsl:attribute>
    </xsl:element>
    <p class="element"><xsl:value-of select="@name"/>ѥ᡼</p>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/dtd/entity/value">
    <p class="elementSection">Ÿ</p>
    <p class="elementInclude"><xsl:apply-templates/></p>
  </xsl:template>

  <xsl:template match="/dtd/entity/desc">
    <p class="elementSection"></p>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="a">
    <xsl:element name="a">
      <xsl:attribute name="name">
        <xsl:value-of select="@name"/>
      </xsl:attribute>
      <xsl:attribute name="href">
        <xsl:value-of select="@href"/>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="p">
    <xsl:element name="p"><xsl:apply-templates/></xsl:element>
  </xsl:template>

  <xsl:template match="i">
    <xsl:element name="i"><xsl:apply-templates/></xsl:element>
  </xsl:template>

  <xsl:template match="b">
    <xsl:element name="b"><xsl:apply-templates/></xsl:element>
  </xsl:template>

  <xsl:template match="tt">
    <xsl:element name="tt"><xsl:apply-templates/></xsl:element>
  </xsl:template>

</xsl:stylesheet>
